unit Unit1;

interface

{
 investigation
 m * [ABCDE..] = [..EDCBA]
} 

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    msglabel: TStaticText;
    Label1: TLabel;
    Label10: TLabel;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const digvalue : array[1..8] of dword = (1,10,100,1000,10000,100000,1000000,10000000);
      Nmax : array[1..8] of dword = (9,98,987,9876,98765,987654,9876543,98765432);
      Nstart : array[1..8] of dword = (0,01,012,0123,01234,012345,0123456,01234567);

type TABCD = array[0..8] of byte;

var ABCD : TABCD;
    digcount : byte;
    busy : boolean;
    XF : boolean;    //exit flag

procedure unpack(w : dword);
//w --> ABCD
var i : byte;
begin
 for i := 0 to digcount-1 do
  begin
   ABCD[i] := w mod 10;
   w := w div 10;
  end;
end;

function packReverse : dword;
//ABCD --> DCBA --> word
var d : dword;
    i : byte;
begin
 d := digvalue[digcount];
 result := 0;
 for i := 0 to digcount-1 do
  begin
   result := result + d*ABCD[i];
   d := d div 10;
  end;
end;

function unique : boolean;
//test digits of ABCD[ ] are unique
var dflag : array[0..9] of boolean;
    a,i : byte;
begin
 result := true;
 for i := 0 to 9 do dflag[i] := false;
 i := 0;
 while result and (i < digcount) do
  begin
   a := ABCD[i];
   if dflag[a] then result := false
    else begin
          dflag[a] := true;
          inc(i);
         end;
  end;
end;

procedure showParams(d : byte);
var s : string;
begin
 s := 'digits = '+inttostr(d);
 form1.msglabel.caption := s;
 application.processmessages;
end;

procedure reportsolution(n : dword; m : byte);
//n : number; m : multiplier
var s : string;
begin
 s := inttostr(n);
 s := s + '  m = '+ inttostr(m);
 form1.Memo1.lines.add(s);
 application.processmessages;
end;

function testnumber(n : dword) : byte;
//test n for solution
//result = 0 : no solution
//result > 0 : multiplier
var m : byte;
    N2 : dword;
begin
 result := 0;
 N2 := packreverse;
 m := 2;
 repeat
  if (m*n) = N2 then
   begin
    result := m;
    exit;
   end;
  inc(m);
 until m = 12;
end;

procedure search;
var i,mptest : byte;
    number : dword;
    timer : dword;   //proc messages
begin
 for i := 2 to 8 do
  begin
   timer := 0;
   digcount := i;
   showparams(i);
   number := Nstart[i];
   repeat
    unpack(number);
    if unique then
     begin
      mptest := testnumber(number);
      if mptest > 0 then reportsolution(number,mptest);
     end; 
    inc(number);
    if timer = 0 then
     begin
      application.ProcessMessages;
      timer := 10000;
     end
     else dec(timer);
   until (number > Nmax[i]) or XF;
  end;//for i
end;

procedure TForm1.Button1Click(Sender: TObject);
//GO button
begin
 if busy then exit;
//
 XF := false;
 busy := true;
 memo1.clear;
 search;
 busy := false;
 msglabel.caption := 'end';
end;

procedure reset;
begin
 xf := true;
 form1.Memo1.clear;
 form1.msglabel.caption := 'start';
end;

procedure TForm1.Button2Click(Sender: TObject);
//reset button
begin
 reset;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 reset;
 msglabel.Caption := 'welcome';
end;

end.
